# class OpenSSL::SSL::Server

- OpenSSL::SSL::Server
- Reference
- Object

##
Overview

This class wraps another `::Socket::Server` in an SSL layer.

    require "socket"
    require "openssl"

    tcp_server = TCPServer.new(0)

    ssl_context = OpenSSL::SSL::Context::Server.new
    ssl_context.certificate_chain = "openssl.crt"
    ssl_context.private_key = "openssl.key"
    ssl_server = OpenSSL::SSL::Server.new(tcp_server, ssl_context)

    puts "SSL Server listening on #{tcp_server.local_address}"
    while connection = ssl_server.accept?
      connection.puts "secure message"
      connection.close
    end

##
Included Modules

- Socket::Server

##
Defined in:

##
Constructors

- .new(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true)

  Creates a new SSL server wrapping wrapped.

##
Class Method Summary

- .open(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true, &)

  Creates a new SSL server wrapping wrapped and yields it to the block.

##
Instance Method Summary

- #accept : OpenSSL::SSL::Socket::Server

  Implements `::Socket::Server#accept`.

- #accept? : OpenSSL::SSL::Socket::Server?

  Implements `::Socket::Server#accept?`.

- #close

  Closes this SSL server.

- #closed? : Bool

  Returns `true` if this SSL server has been closed.

- #context : OpenSSL::SSL::Context::Server

  Returns the SSL context.

- #local_address : ::Socket::Address

  Returns local address of `#wrapped`.

- #sync_close=(sync_close : Bool)

  If `#sync_close?` is `true`, closing this server will close the wrapped server.

- #sync_close? : Bool

  If `#sync_close?` is `true`, closing this server will close the wrapped server.

- #wrapped : ::Socket::Server

  Returns the wrapped server socket.

### Instance methods inherited from module `Socket::Server`

accept : IO
accept(&) accept, accept? : IO?
accept?(&) accept?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true) #

Creates a new SSL server wrapping wrapped.

context configures the SSL options, see `OpenSSL::SSL::Context::Server` for details

##
Class Method Detail

def self.open(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true, &) #

Creates a new SSL server wrapping wrapped and yields it to the block.

context configures the SSL options, see `OpenSSL::SSL::Context::Server` for details

The server is closed after the block returns.

##
Instance Method Detail

def accept : OpenSSL::SSL::Socket::Server #

Implements `::Socket::Server#accept`.

This method calls `@wrapped.accept` and wraps the resulting IO in a SSL socket (`OpenSSL::SSL::Socket::Server`) with `#context` configuration.

def accept? : OpenSSL::SSL::Socket::Server? #

Implements `::Socket::Server#accept?`.

This method calls `@wrapped.accept?` and wraps the resulting IO in a SSL socket (`OpenSSL::SSL::Socket::Server`) with `#context` configuration.

def close #

Closes this SSL server.

Propagates to `#wrapped` if `sync_close` is `true`.

def closed? : Bool #

Returns `true` if this SSL server has been closed.

def context : OpenSSL::SSL::Context::Server #

Returns the SSL context.

def local_address : ::Socket::Address #

Returns local address of `#wrapped`.

def sync_close=(sync_close : Bool) #

If `#sync_close?` is `true`, closing this server will close the wrapped server.

def sync_close? : Bool #

If `#sync_close?` is `true`, closing this server will close the wrapped server.

def wrapped : ::Socket::Server #

Returns the wrapped server socket.